<!-- This component is used to render a single house as a card, it includes links to both the agent and the extended information of the house -->

<template>
  <div class="container" v-if="listing != null " v-observe-visibility="visibilityChanged">
    <router-link :to="'/house/' + listingId + '/' + agentId" style="text-decoration: none; color: black;">
    <div class="innerContainer">
      <img alt="Loading" v-bind:src="src">
      <div class="header">
        <h3>{{listing.address}}</h3>
        <p>{{listing.description}}</p>
      </div>
      <div class="agent">
        <div>
          <router-link :to="'/agent/' + agentId " style="text-decoration: none;"><ProfilePic :circle="true" height="80px" width="80px" :img="agent.profile_image"/>
          <p>{{agent.first_name}} {{agent.last_name}}</p></router-link>
          
        </div>
      </div>
    </div>
  </router-link>
  </div>
</template>

<script>
import Data from '../../global/variable.js'
import ProfilePic from '.././ProfilePic'
export default {
  name: 'HouseCard',
  components: {
    ProfilePic
  },
  props: {
    agentId: Number,
    listingId: Number
  },
  data() {
      return {
          listing: null,
          agent: null,
          src: '',
      }
  },
  mounted() {
      this.agent = Data.getAgent(this.agentId)
      this.listing = Data.getListing(this.agentId, this.listingId)

  },
  methods : {
    visibilityChanged(isVisible) { // Triggers when an element is in the viewport or not.
        if(isVisible && this.src === '') {
          let index = Math.floor(Math.random() * this.listing.images.length)
          this.src = this.listing.images[index]
        }
    },
  }
}
</script>

<style scoped>

  .container {
    margin-top: 2px;
    display: grid;
    place-items: center;
    margin-bottom: 5px;
    text-align: center;
  }
  .innerContainer {
    width: 80vw;
    min-height: 200px;
    max-height:250px;
    border: 1px solid;
    border-color: rgba(0, 0, 0, 0.1);
    border-radius: 10px;
    display: grid;
    grid-template-columns: 3fr 4fr 2fr;
    box-shadow: 2px 3px 10px rgba(0, 0, 0, 0.1);
    overflow:hidden;
  }
  .container :hover {
    border-color: rgba(0, 0, 0, 0.4);
  }
  img {
    width: 100%;
    height: 100%;
    border-radius: 10px 0px 0px 10px;
    border-right: 2px solid;
        border-color: rgba(0, 0, 0, 0.3);
  }
  .header {
    margin-left: 3px;
    font-family: 'Quicksand', sans-serif;
    width: 100%;
  }
  .header > p {
    margin-left: 4px;
    word-wrap:break-word;
  }
  .agent {
    display:grid;
    place-items: center;
   font-family: 'Quicksand', sans-serif;
  }
</style>